<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_residency".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderResidency".
 *
 * Columns in table "provider_residency" available as properties of the model,
 * followed by relations of table "provider_residency" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $residency_type_id
 * @property string $hospital_name
 * @property string $area_of_focus
 * @property integer $year_completed
 *
 * @property ResidencyType $residencyType
 * @property Provider $provider
 */
abstract class BaseProviderResidency extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_residency';
    }

    public static function representingColumn()
    {
        return 'hospital_name';
    }

    public function rules()
    {
        return array(
            array('provider_id, residency_type_id, hospital_name', 'required'),
            array('provider_id, residency_type_id, year_completed', 'numerical', 'integerOnly' => true),
            array('hospital_name', 'length', 'max' => 255),
            array('area_of_focus', 'length', 'max' => 100),
            array('area_of_focus, year_completed', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, residency_type_id, hospital_name, area_of_focus, year_completed', 'safe',
                'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'residencyType' => array(self::BELONGS_TO, 'ResidencyType', 'residency_type_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'residency_type_id' => Yii::t('app', 'Type of Training'),
            'hospital_name' => Yii::t('app', 'Name of Institution'),
            'area_of_focus' => Yii::t('app', 'Area Of Focus'),
            'year_completed' => Yii::t('app', 'Year Completed'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        //this is to enable eager loading - looks like it's no good to add provider here
        $criteria->with = array('residencyType', 'provider');

        //$criteria->compare('id', $this->id);
        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else {
            $criteria->compare('provider_id', $this->provider_id);
        }
        $criteria->compare('residency_type_id', $this->residency_type_id);
        $criteria->compare('hospital_name', $this->hospital_name, true);
        $criteria->compare('area_of_focus', $this->area_of_focus, true);
        $criteria->compare('year_completed', $this->year_completed);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 100)
        ));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderResidency|ProviderResidencys', $n);
    }

}
